<template>
  <div>
    <div v-if="disabled">
      <b-input :value="formatDateShort(inputValue)" disabled></b-input>
    </div>
    <datetime
      ref="theDateTime"
      v-else
      :value="inputValue"
      @input="onInput"
      :max-datetime="maxDatetime"
      :min-datetime="minDatetime"
      :title="title"
      :placeholder="placeholder"
      :input-class="inputClasses"
      :type="type"
      :zone="zone"
      class="input-group"
    >
      <template slot="before">
        <div @click="openDateTime" class="input-group-prepend cursor-pointer">
          <span class="input-group-text">
            <font-awesome-icon :icon="['fas', 'calendar-alt']" />
          </span>
        </div>
      </template>
      <template slot="after">
        <div
          @click="clearValue"
          v-if="enableClearButton"
          class="input-group-append cursor-pointer"
        >
          <span class="input-group-text">
            <font-awesome-icon :icon="['fas', 'times']" />
          </span>
        </div>
      </template>
      <template slot="button-cancel">
        {{ $t('button.cancel') }}
      </template>
      <template slot="button-confirm">
        {{ $t('button.ok') }}
      </template>
    </datetime>
  </div>
</template>

<script>
import DateTimeFormatMixin from '../mixins/DateTimeFormatMixin';

export default {
  mixins: [DateTimeFormatMixin],
  props: {
    value: {
      type: String,
      default: null,
    },
    maxDatetime: {
      type: String,
      default: null,
    },
    minDatetime: {
      type: String,
      default: null,
    },
    placeholder: {
      type: String,
      default: '',
    },
    title: {
      type: String,
      default: '',
    },
    state: {
      type: Boolean,
      default: null,
    },
    enableClearButton: {
      type: Boolean,
      default: false,
    },
    type: {
      type: String,
      default: 'date',
    },
    zone: {
      type: String,
      default: 'UTC',
    },
    disabled: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      inputValue: this.value,
    };
  },
  computed: {
    inputClasses() {
      let c = 'form-control cursor-pointer';

      if (!this.enableClearButton) {
        c = c + ' form-control-border-end';
      }

      if (this.state === true) {
        c = c + ' is-valid';
      } else if (this.state === false) {
        c = c + ' is-invalid';
      }

      return c;
    },
  },
  methods: {
    openDateTime() {
      this.$refs.theDateTime.open({ target: { blur: () => {} } });
    },
    clearValue() {
      this.$refs.theDateTime.setValue({ target: { value: null } });
    },
    onInput(value) {
      if (!(value instanceof Event)) {
        this.$emit('input', value);
      }
    },
  },
};
</script>
